<?php
namespace Teknisa\MAN\Controllers;


use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Teknisa\MAN\Services\DayPartModalidadeService;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;
use Zeedhi\Framework\DTO\Response\Message;
use Teknisa\MAN\Services\NovoCodigo;
 

class DayPartModalidade  {
    protected $dataSourceName = 'vnd03101_DaypartModalidade';
    protected $DayPartModalidadeService;
    protected $utilService;
    
    public function __construct (DayPartModalidadeService $DayPartModalidadeService, Utilities\Util $utilService ){
        $this->utilService = $utilService;
        $this->dayPartModalidadeService = $DayPartModalidadeService;
    }
    
    public function find($request, $response) {
        $result = [];
        $conditions = $this->utilService->getParamsAsArray($request);
        
        if(isset($conditions['CDFILIAL']) && !empty($conditions['CDFILIAL'])) {
            $result = $this->dayPartModalidadeService->buscaDayPart($conditions);
            $response->addDataSet(new DataSet("vnd03101_DaypartModalidade", $result));
        }
        
        return $result;
    }
    
    public function findByProd($request, $response) {
        $result = [];
        $conditions = $this->utilService->getParamsAsArray($request);
        
        if(isset($conditions['CDFILIAL']) && !empty($conditions['CDFILIAL'])) {
            $result = $this->dayPartModalidadeService->buscaDayPartProd($conditions);
            $response->addDataSet(new DataSet("vnd03102_relDaypartProdutoModalidade", $result));
        }
        
        return $result;
    }
}