<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class BloqueioLojaService {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
        
    }
    
    public function bloqueiaLoja($lojas, $isNew) {
        $this->entityManager->getConnection()->beginTransaction();
        $all = false;
        try{
            foreach ($lojas as $loja) {
            	$params = array(
                	":CDFILIAL" => $loja['CDFILIAL'],
			     	":CDLOJA" => $loja['CDLOJA'],
			     	":CDOPERADOR" => $loja['CDOPERADOR'],
			     	":IDATIVO" => $loja['IDATIVO'],
			     	":NRDIASEMANABLOQ" => $loja['NRDIASEMANABLOQ'],
			     	":NRORG" => $loja['NRORG']
                );
                if ($loja['NRDIASEMANABLOQ'] === 'T'){
			     	$all = true;
			     	$paramAll = $params;
			    }
                $this->entityManager->getConnection()->executeQuery(self::INSERT_BLOCKED_STORE, $params);
            }
            if ($all){
            	$this->entityManager->getConnection()->executeQuery(self::DELETE_ALL_SINGLE_BLOCKED_STORE, $paramAll);
            }
            else{
            	$this->entityManager->getConnection()->executeQuery(self::DELETE_ALL_FROM_BLOCKED_STORE, $params);
            }

            $this->entityManager->getConnection()->commit();
        }catch(Exception $e){
            $this->entityManager->getConnection()->rollBack();
        }
    }
    
    public function bloqueiaLojas($lojas, $isNew) {
        $this->entityManager->getConnection()->beginTransaction();
        try{
            foreach ($lojas as $loja) {
            	$params = array(
                	":CDFILIAL" => $loja['CDFILIAL'],
			     	":CDLOJA" => $loja['CDLOJA'],
			     	":NRORG" => $loja['NRORG']
                );
                $this->entityManager->getConnection()->executeQuery(self::DELETE_ALL_DAYS, $params);
            }
            
            foreach ($lojas as $loja) {
            	$params = array(
                	":CDFILIAL" => $loja['CDFILIAL'],
			     	":CDLOJA" => $loja['CDLOJA'],
			     	":CDOPERADOR" => $loja['CDOPERADOR'],
			     	":IDATIVO" => $loja['IDATIVO'],
			     	":NRDIASEMANABLOQ" => $loja['NRDIASEMANABLOQ'],
			     	":NRORG" => $loja['NRORG']
                );
                $this->entityManager->getConnection()->executeQuery(self::INSERT_BLOCKED_STORE, $params);
            }

            $this->entityManager->getConnection()->commit();
        }catch(Exception $e){
            $this->entityManager->getConnection()->rollBack();
        }
    }
    
  
	/*public function bloqueiaProduto($produtos, $isNew) {
		$this->entityManager->getConnection()->beginTransaction();
		try {
		    foreach($produtos as $prod) {
				$params = array(
				   	":CDFILIAL" => $prod['CDFILIAL'],
			     	":CDLOJA" => $prod['CDLOJA'],
			     	":CDPRODUTO" => $prod['CDPRODUTO'],
			     	":CDOPERADOR" => $prod['CDOPERADOR'],
			     	":NRDIASEMANABLOQ" => $prod['NRDIASEMANABLOQ'],
			     	":NRORG" => $prod['NRORG']
			 	);
				$this->entityManager->getConnection()->executeQuery(self::INSERT_BLOCKED_PRODUCT, $params);
				
			}
			$this->entityManager->getConnection()->commit();
		} catch (\Exception $e) {
		$this->entityManager->getConnection()->rollBack();
		}
	}*/
	
	public function desbloqueiaLoja($NRORG, $CDFILIAL, $CDLOJA, $CDOPERADOR, $NRDIASEMANABLOQ) {
	      $params = array(
         	":CDFILIAL" =>	$CDFILIAL,
         	":CDLOJA" =>	$CDLOJA,
         	":CDOPERADOR" =>	$CDOPERADOR,
         	":NRDIASEMANABLOQ" =>	$NRDIASEMANABLOQ,
         	":NRORG" =>	$NRORG
     		);
     		$response = $this->entityManager->getConnection()->executeQuery(self::DELETE_BLOCKED_STORE, $params);
	    return $response;
	}
	
	const INSERT_BLOCKED_STORE = "
    	INSERT INTO LOJABLOQ
    		(CDFILIAL, CDLOJA, CDOPERADOR, DTHRBLOQUEIO, NRDIASEMANABLOQ, NRORG, IDATIVO)
    	 VALUES
    		(:CDFILIAL, :CDLOJA, :CDOPERADOR, TO_DATE(SYSDATE, 'DD/MM/YYYY HH24:MI:SS'), :NRDIASEMANABLOQ, :NRORG, :IDATIVO)
    ";
    
    const DELETE_BLOCKED_STORE = "
    	DELETE FROM LOJABLOQ
    	 WHERE CDFILIAL 	   = :CDFILIAL
    	   AND CDLOJA   	   = :CDLOJA
    	   AND NRDIASEMANABLOQ = :NRDIASEMANABLOQ
    	   AND NRORG		   = :NRORG
    ";
    const DELETE_ALL_SINGLE_BLOCKED_STORE = "
    	DELETE FROM LOJABLOQ
    	 WHERE CDFILIAL 	   = :CDFILIAL
    	   AND CDLOJA   	   = :CDLOJA
    	   AND NRORG		   = :NRORG
    	   AND NRDIASEMANABLOQ <> 'T'
    ";
    
    const DELETE_ALL_DAYS = "
    	DELETE FROM LOJABLOQ
    	 WHERE CDFILIAL 	   = :CDFILIAL
    	   AND CDLOJA   	   = :CDLOJA
    	   AND NRORG		   = :NRORG
    ";
    
    const DELETE_ALL_FROM_BLOCKED_STORE = "
    	DELETE FROM LOJABLOQ
    	 WHERE CDFILIAL 	   = :CDFILIAL
    	   AND CDLOJA   	   = :CDLOJA
    	   AND NRORG		   = :NRORG
    	   AND NRDIASEMANABLOQ = 'T'
    ";
}