<?php

namespace Teknisa\MAN\Services;

use Teknisa\Libs\Util\Libraries\PHPMailer;

class SMTPManagement {

	const ZEND_ENCRYPTION_ID_NONE  = 'sem';
	const ZEND_ENCRYPTION_ID_TLS   = 'tls';
	const ZEND_ENCRYPTION_ID_SSL   = 'ssl';
	
	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager) {
		$this->entityManager = $entityManager;
	}

	public function getSMTP(){
		return $this->entityManager->getConnection()->fetchAll(self::GET_SMTP);
	}

	public function getSMTPFilial($CDFILIAL){
		$params = array(
			':CDFILIAL' => $CDFILIAL
		);

		return $this->entityManager->getConnection()->fetchAll(self::GET_SMTP_FILIAL, $params);
	}

	public function sendEmail($name_addressee, $email_addressee, $sender, $subject, $content) {
		
		// Get data from server
        $SMTP = $this->getSMTP();
        $username 	        = $SMTP[0]['DSEMAILAUVND'];
        $loginSMTP 	        = $SMTP[0]['DSSMTPLOGIN'];
        $server   	        = $SMTP[0]['DSSMTPAUTVND'];
        $password 	        = $SMTP[0]['CDSENHAAUTVNDWEB'];
        $port     	        = $SMTP[0]['NRPORTAAUTVND'];
        $encryptionProtocol = $SMTP[0]['DSSMTPCRIPT'];
        $auth				= $SMTP[0]['IDTPAUTHSMTP'];
        $message            = self::generateEmail($subject, $content);
        
    	$mail = new PHPMailer(true);
		$mail->CharSet    = "UTF-8";
        $mail->Encoding   = "base64";
        $mail->isSMTP();         
        $mail->IsHTML(true);
        $mail->Host       = $server;       // Specify main and backup SMTP servers
        $mail->SMTPAuth   = ($auth == 'S') ? true : false;   // Enable SMTP authentication
        $mail->Username   = $loginSMTP == null ? $username :$loginSMTP;   // SMTP username
        $mail->Password   = $password;   // SMTP password
        $mail->Port       = $port;
        $mail->SMTPSecure = $encryptionProtocol;
        $mail->From       = $username;
        $mail->FromName   = $sender;
        $mail->Subject    = $subject;
        $mail->Body       = $message;
        $mail->addAddress($email_addressee); // Add a recipient
        //var_dump($loginSMTP);die;
        $result = $mail->send();
        if(!$result) {
            throw new \Exception($mail->ErrorInfo);
        }
    }
    
    // email with raw body
    public function sendRawEmail($name_addressee, $email_addressee, $sender, $subject, $content) {
    		// Get data from server
        $SMTP = $this->getSMTP();
        $username 	        = $SMTP[0]['DSEMAILAUVND'];
        $loginSMTP 	        = $SMTP[0]['DSSMTPLOGIN'];
        $server   	        = $SMTP[0]['DSSMTPAUTVND'];
        $password 	        = $SMTP[0]['CDSENHAAUTVNDWEB'];
        $port     	        = $SMTP[0]['NRPORTAAUTVND'];
        $encryptionProtocol = $SMTP[0]['DSSMTPCRIPT'];
        $auth				= $SMTP[0]['IDTPAUTHSMTP'];
        
    	$mail = new PHPMailer(true);
		$mail->CharSet    = "UTF-8";
        $mail->Encoding   = "base64";
        $mail->isSMTP();         
        $mail->IsHTML(true);
        $mail->Host       = $server;       // Specify main and backup SMTP servers
        $mail->SMTPAuth   = ($auth == 'S') ? true : false;   // Enable SMTP authentication
        $mail->Username   = $loginSMTP == null ? $username :$loginSMTP;   // SMTP username
        $mail->Password   = $password;   // SMTP password
        $mail->Port       = $port;
        $mail->SMTPSecure = $encryptionProtocol;
        $mail->From       = $username;
        $mail->FromName   = $sender;
        $mail->Subject    = $subject;
        $mail->Body       = $content;
        $mail->addAddress($email_addressee); // Add a recipient
        //var_dump($loginSMTP);die;
        $result = $mail->send();
        if(!$result) {
            throw new \Exception($mail->ErrorInfo);
        }
        
        return $result;
    }

    public function generateEmail($subject, $content) {
    	return
    		'<!DOCTYPE html>'.
            '<head>'.
			'<style>'.
				"@import url('https://fonts.googleapis.com/css?family=Cuprum|Prompt');".
		    	"@import url('https://fonts.googleapis.com/css?family=Martel+Sans');".
		        "
		        .tableLine {
		            background-color: #E6D7CF;
		        }
		        #tabela {
		            border-collapse: collapse;
		            border-spacing: 0;
		            width:100%;
		            height:100%;
		            margin:0px;
		            padding:0px;
		        }
		        body{
		            background-color: #E6D7CF;
		            height: 100%;
		        }
		        #tituloEmail {
		            font-family: 'Martel Sans', sans-serif;
		            font-size: 45px;
		            background-color: #a24e22;
		            color: #ffffff;
		        }
		        #emailBody {
		            padding-top: 5%;
		            font-family: 'Cuprum', sans-serif;
		            font-size: 25px;
		            text-align: center;
		            vertical-align: 25%;
		            padding-bottom: 5%;
		        }
		        #linhaTitulo {
		            height: 5px;
		            background-color: #b75826;
		        }".
			'</style>'.
			'<meta http-equiv="content-type" content="text/html; charset=UTF-8">'.
			'</head>'.
			'<body>'.
			'<div class="tabelaEmail">
	         <table id="tabela" >
	            <tr class="tableLine">
	               <td valign="top" align="center">
	                    <div id="tituloEmail">'.
	                      $subject
	                    .'</div>
	                    <div id="linhaTitulo"></div>
	               </td>
	            </tr>
	            <tr class="tableLine">
	               <td>
	                 <div id="emailBody">'.
	                    $content
	                 .'<br><img src="https://manage.teknisa.com/assets/images/logo/default.png?v" style="width: 250px;">
	             	 </div>
	               </td>
	            </tr>
	         </table>
	        </div>'.
			'</body>'.
			'</html>'
		;
	}
	
	private function setEncryptionParams(&$zendOptions, $encryptionProtocol) {
		switch($encryptionProtocol) {
			case SMTPManagement::ZEND_ENCRYPTION_ID_NONE :
				$zendOptions['connection_class'] = 'login';
				unset($zendOptions['connection_config']['ssl']);
				break;
			case SMTPManagement::ZEND_ENCRYPTION_ID_TLS : 
				$zendOptions['connection_class'] = 'plain';
				break;
			case SMTPManagement::ZEND_ENCRYPTION_ID_SSL : 
			default :
				break;
		}
	}
	
	const GET_SMTP_FILIAL = "
		SELECT DSEMAILCLUSO
		FROM PARAVEND
		WHERE CDFILIAL = :CDFILIAL
	";
	
	const GET_SMTP = "
		SELECT DSSMTPAUTVND, DSEMAILAUVND, NRPORTAAUTVND, CDSENHAAUTVNDWEB,
			DSEMAILCLUSO, LOWER(DSSMTPCRIPT) AS DSSMTPCRIPT, IDTPAUTHSMTP, DSSMTPLOGIN
		FROM PARAMGERAL
	";

}